package djmil.cordacheckers.cordaclient.dao.flow.arguments;

import djmil.cordacheckers.cordaclient.dao.GameState;
import djmil.cordacheckers.cordaclient.dao.flow.RequestBody;

public interface Rsp <T> {
    public T successStatus();
    public String failureStatus();

    public default T getResponce(RequestBody requestBody) {
        if (failureStatus() == null) {
            final var responce = successStatus();
            final String gameUuid = (responce instanceof GameState) 
               ? "GameUUID " +((GameState)responce).uuid().toString()
               : "";
            
            System.out.println(requestBody.clientRequestId() +" [OK] " +gameUuid);

            return responce;
        }

        System.err.println(requestBody.clientRequestId() +" has failed: " +failureStatus());
        throw new RuntimeException(failureStatus());
    }

}
